   .hrom
   .base $000200 ; main program
   .org $200

   PPUREADY    =     $C000     
   PPU         =     $C001    
   RESET       =     $FFFC

         JSR.w    WaitForKey
         JSR.w    INIT

         LDA.w    HelloMSG
         STA.w    MessageToDraw+1
         LDA.w    HelloMSG+1
         STA.w    MessageToDraw+2
         JSR.w    PRINTMSG

         JSR.w    WaitForKey

         LDA.w    RESET
         STA.w    Reboot+1
         LDA.w    RESET+1
         STA.w    Reboot+2

Reboot:  JMP.w    RESET


   INIT:
         LDA.b    #$90   ;X=0
         JSR.w    WRITEPPU
         LDA.b    #$A0   ;Y=0
         JSR.w    WRITEPPU
         LDY.b    #$00
   -     LDA.b    #$7F
         JSR.w    WRITEPPU
         INY
         BNE   -
         LDY.b    #$F7
   -     LDA.b    #$7F
         JSR.w    WRITEPPU
         INY
         BNE   -
         LDA.b    #$90     ;X=0
         JSR.w    WRITEPPU
         LDA.b    #$A0     ;Y=0
         JSR.w    WRITEPPU
         RTS

WRITEPPU:
         STA.w    PPU
-        LDA.w    PPUREADY
         LSR      A
         BCC      -
         RTS

WaitForKey:
         JSR.w    ReadKeypad1
         LDA.w    Keypad1
         AND.b    #$FF
         BEQ.w    WaitForKey
-        JSR.w    ReadKeypad1
         LDA.w    Keypad1
         AND.b    #$FF
         BNE.w    -
         RTS

ReadKeypad1:
         LDY.b    #$01
         STY.w    $4016
         LDY.b    #$00
         STY.w    $4016
         LDX.b    #$F8
-
         LDA.w    $4016
         LSR      A
         ROL.w    Keypad1
         INX
         BNE.w    -
         RTS

PRINTCHR:
         CMP.b    #$20
         BNE      PRINTCHR1
         LDA.b    #$7F
         BNE      PRINTCHRQ
PRINTCHR1:
         CMP.b    #'<'
         BNE      PRINTCHR2
         LDA.b    #$0B
         BNE      PRINTCHRQ
PRINTCHR2:
         CMP.b    #'>'
         BNE      PRINTCHR3
         LDA.b    #$0C
         BNE      PRINTCHRQ
PRINTCHR3:
         CMP.b    #45
         BEQ      PRINTCHR3A
         CMP.b    #'_'
         BNE      PRINTCHR4
PRINTCHR3A:
         LDA.b    #$0D
         BNE      PRINTCHRQ
PRINTCHR4:
         CMP.b    #'.'
         BNE      PRINTCHR5
         LDA.b    #$0E
         BNE      PRINTCHRQ
PRINTCHR5:
         CMP.b    #','
         BNE      PRINTCHR6
         LDA.b    #$0F
         BNE      PRINTCHRQ
PRINTCHR6:
         CMP.b    #'O'
         BNE      PRINTCHR7
         LDA.b    #$00        ; USE '0' FOR 'O'
         BEQ      PRINTCHRQ
PRINTCHR7:
         CMP.b    #47
         BNE      PRINTCHR8
         LDA.b    #$6D
         BNE      PRINTCHRQ
PRINTCHR8:
         CMP.b    #'a'
         BCC      PRINTCHR9
         CMP.b    #'z'+1
         BCS      PRINTCHRQ
         SEC
         SBC.b    #$10
         JMP      WRITEPPU
PRINTCHR9:
         SEC
         SBC.b    #$30
PRINTCHRQ:
         JMP   WRITEPPU

PRINTMSG:
         LDY.b    #$00
AgainMSG:
MessageToDraw:
         LDA.w    buffer,y
         CMP.b    #$FF
         BEQ      MessageDoneMSG
         JSR      PRINTCHR
         INY
         BNE      AgainMSG
MessageDoneMSG:
         RTS

Hello:         .dcb $91,$A0,'Hello world',$92,$A0,$FF
HelloMSG:      .dcw Hello

   .pad $07FF
   buffer:
   Keypad1:  .dcb $FF
